Package: diffUTR
Type: Package
Title: diffUTR: Streamlining differential exon and 3' UTR usage
Version: 1.20.0
Depends: R (>= 4.0)
Authors@R: c(
	person("Pierre-Luc", "Germain", email="pierre-luc.germain@hest.ethz.ch", 
	  role=c("cre","aut"), comment = c(ORCID = "0000-0003-3418-4218")), 
	person("Stefan", "Gerber", email="gerberst@student.ethz.ch", role="aut") )
Description: 
    The diffUTR package provides a uniform interface and plotting functions for
    limma/edgeR/DEXSeq -powered differential bin/exon usage. It includes in 
    addition an improved version of the limma::diffSplice method. Most 
    importantly, diffUTR further extends the application of these frameworks to 
    differential UTR usage analysis using poly-A site databases.
Imports: S4Vectors, SummarizedExperiment, limma, edgeR, DEXSeq,
        GenomicRanges, Rsubread, ggplot2, rtracklayer, ComplexHeatmap,
        ggrepel, stringi, methods, stats, GenomeInfoDb, dplyr,
        matrixStats, IRanges, ensembldb, viridisLite
Suggests: BiocStyle, knitr, rmarkdown
biocViews: GeneExpression
BugReports: https://github.com/ETHZ-INS/diffUTR
VignetteBuilder: knitr
License: GPL-3
Encoding: UTF-8
RoxygenNote: 7.1.2
git_url: https://git.bioconductor.org/packages/diffUTR
git_branch: RELEASE_3_23
git_last_commit: ba87eee
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:59:07 UTC; biocbuild
Author: Pierre-Luc Germain [cre, aut] (ORCID:
    <https://orcid.org/0000-0003-3418-4218>),
  Stefan Gerber [aut]
Maintainer: Pierre-Luc Germain <pierre-luc.germain@hest.ethz.ch>
Built: R 4.6.0; ; 2026-04-29 04:40:35 UTC; unix

#' addNormalizedAssays
#'
#' @param se A bin-wise `SummarizedExperiment` as produced by
#' \code{\link{countFeatures}}
#'
#' @return The `se` object with populated `logcpm` and `logNormDensity` assays.
#' @param readLength Used as a minimum width to estimate read density
#' (default 50).
#' @export
#'
#' @importFrom edgeR DGEList cpm calcNormFactors
#' @examples
#' data(example_bin_se)
#' example_bin_se <- addNormalizedAssays(example_bin_se)
addNormalizedAssays <- function(se, readLength=50L){
  cpm <- cpm(calcNormFactors(DGEList(assay(se))))
  assays(se)$logcpm <- log1p(cpm)
  assays(se)$logNormDensity <- log1p(1000*cpm/pmax(width(se),readLength))
  se
}

#' @importFrom stringi stri_reverse
.cleanNames <- function(x){
  x <- gsub(" ","_",gsub("-","_",gsub("/",".",x,fixed=TRUE),fixed=TRUE),
            fixed=TRUE)
  x <- rmLCS(rmLCS(x,"."),"_")
  stri_reverse(rmLCS(rmLCS(stri_reverse(x),"."),"_"))
}


.matchGene <- function(se, x){
  w <- which(rowData(se)$gene == x)
  if(length(w)==0) w <- which(any(rowData(se)$gene_name == x))
  w
}


# remove the longest common string at the beginning of all elements of a
# character vector
rmLCS <- function(x, delim=""){
  if(length(x)==1) return(x)
  tmp <- strsplit(as.character(x),delim,fixed=TRUE)
  if(any(lengths(tmp)==1)) return(x)
  i <- 1
  while(length(unique(vapply(tmp, FUN.VALUE=character(1),
                             FUN=function(x) x[i])))==1){
    i <- i+1
  }
  if(i==1) return(x)
  vapply(tmp, FUN.VALUE=character(1), FUN=function(x){
    x <- x[!is.null(x)]
    paste(x[-seq_len(i-1)], collapse=delim)
  })
}

.typeColors <- function(){
  c("3UTR"="#117733", "CDS"="#332288", "CDS/3UTR"="#44AA99",
    "CDS/UTR"="#44AA99", "CDS/UTR/3UTR"="#44AA99", "UTR"="#DDCC77",
    "UTR/3UTR"="#999933", "non-coding"="#CC6677")
}

#' @importFrom methods is
.checkSE <- function(se, checkNorm=FALSE, requireStats=FALSE){
  stopifnot(is(se,"RangedSummarizedExperiment"))
  stopifnot(all(c("type","meanLogCPM","logWidth","meanLogDensity","gene") %in%
                  colnames(rowData(se))))
  if(requireStats){
    if( !all(c("bin.p.value","bin.FDR") %in% colnames(rowData(se))) ||
        is.null(gl <- metadata(se)$geneLevel) ||
        !(is.data.frame(gl) || is(gl, "DFrame")))
      stop("The object does not contain differential bin usage statistics. ",
           "You should run a DEU wrapper first (see `?DEUwrappers`).")
  }
  if(checkNorm){
    if(!all(c("logcpm","logNormDensity") %in% assayNames(se))){
      message("Computing normalized assays...")
      message("To avoid doing this again for every plot, run:\n",
              "se <- addNormalizedAssays(se)")
      se <- addNormalizedAssays(se)
    }
  }
  if(is.null(rowData(se)$logDensityRatio))
    rowData(se)$logDensityRatio <-
      log(.getDensityRatio(rowData(se)$meanLogDensity, rowData(se)$gene))
  se
}

.getDensityRatio <- function(logNormDensity, gene){
  stopifnot(length(logNormDensity)==length(gene))
  de <- splitAsList(exp(as.numeric(logNormDensity))-1, gene)
  geneTopDensity <- vapply(-1*(sort(de)*-1), FUN.VALUE=numeric(1),
                           FUN=function(x) mean(head(x,n=3)))
  round(as.numeric(unlist(de)/geneTopDensity[gene]),3)
}

#' prepareBins
#'
#' @param g A GRanges (or path to RDS file containing a GRanges) or path to a
#' gtf file or EnsDb object containing the gene annotation.
#' @param APA A GRanges (or path to a GRanges in RDS format) or bed file
#' containing the alternative poly-A site database
#' @param onlyMainChr Logical; whether to keep only main chromosomes
#' @param removeAntisense Logical; whether to remove antisense APA sites
#' @param chrStyle Chromosome notation to convert to (default no conversion)
#' @param maxUTRbinSize Max width of new alternative UTR bins
#' @param genewise Logical, whether annotation should be flattened genewise
#' @param stranded Logical, whether to perform disjoin in a stranded fashion.
#' @param codingOnly Logical, whether to keep only coding transcripts
#' @param verbose Logical, whether to print run information
#'
#' @details See the vignette for more details.
#'
#' @return A `GRanges` object.
#'
#' @author Stefan Greber
#' @export
#' @import GenomicRanges rtracklayer GenomeInfoDb
#' @importFrom S4Vectors mcols
#' @importFrom IRanges FactorList CharacterList extractList
#' @examples
#' data(example_gene_annotation)
#' bins <- prepareBins(example_gene_annotation)
prepareBins <- function( g, APA=NULL, onlyMainChr=TRUE, removeAntisense=TRUE,
                         chrStyle=NULL, maxUTRbinSize=15000,
                         codingOnly=FALSE,
                         genewise=FALSE, stranded=FALSE, verbose=TRUE ){

  if(verbose) message("Preparing annotation")
  if(!is.null(APA)) APA <- .prepAPA(APA)
  g <- .prepGeneAnno(g, verbose=verbose)

  if(onlyMainChr){
    #Extract only main chromosomes
    g <- keepStandardChromosomes(g, pruning.mode="coarse")
    if(!is.null(APA))
      APA <- keepStandardChromosomes(APA, pruning.mode="coarse")
  }
  if(!is.null(chrStyle)) seqlevelsStyle(g) <- chrStyle
  seqlevels(g) <- seqlevelsInUse(g)

  if(!is.null(APA)){
    if(verbose) message("Generating alternative UTR bins")
    if(is.null(intersect(seqlevels(APA),seqlevels(g)))) 
      stop("There are no chromosome in common between `g` and `APA`. Consider",
           " using the `chrStyle` argument to force a notation.")
    if(!is.null(chrStyle)) seqlevelsStyle(APA) <- chrStyle
    seqlevels(APA) <- seqlevelsInUse(APA)
    g <- .extendWithAPA(g, APA)
  }

  if(codingOnly) g <- g[g$tx_biotype=="protein_coding"]

  if(verbose) message("Merging and disjoining bins")

  if(genewise){
    bins <- .disjoinGeneWise(g)
  } else{
    bins <- disjoin(g, with.revmap=TRUE, ignore.strand=!stranded)
    f <- rep(seq_along(bins), lengths(bins$revmap))
    mcols(bins) <- DataFrame(lapply( mcols(g)[unlist(bins$revmap),],
                                     FUN=function(x){
                                       sort(unique(splitAsList(x,f)))
                                     }))
  }
  rm(g)

  bt <- CharacterList(bins$type)
  if(is.null(APA)){
    bt <- as.factor(ifelse(any(bt=="CDS"), "CDS", "UTR"))
  }else{
    #concatenate the lists with a + as seperator so each combination of
    # transcripts or type has a unique string as identifier
    #bins$type <- unstrsplit(CharacterList(bins$type),sep="+")
    bt <- 100L*any(bt=="CDS") + 10L*any(bt=="UTR") +
      as.integer(any(bt=="3UTR"))
    dict <- c("111"="CDS/UTR/3UTR", "110"="CDS/UTR", "100"="CDS",
              "11"="UTR/3UTR", "10"="UTR", "1"="3UTR")
    bt <- factor(bt, as.integer(names(dict)), as.character(dict))
  }
  bins$type <- bt
  rm(bt)

  levels(bins$type) <- c(levels(bins$type), "non-coding")
  bins$tx <- unstrsplit(CharacterList(bins$tx), sep="+")

  # duplicate ranges with more then one overlapping gene so each gene has a
  # separate range

  #find the number of genes overlapping this bin
  len<-lengths(bins$gene)
  #for each bin repeat its index as many times as genes overlapping it
  repid<-rep(seq_along(bins),len)
  #save gene_id list for after
  gene_id=bins$gene
  #index bins with index created before in order to multiply the bins as many
  #times as genes overlapping it
  bins<-bins[repid]
  #overwrite the gene_id so that each multipl of a bin has only one
  bins$gene<-unlist(gene_id)
  for(f in c("gene_name", "tx_biotype")){
    if(f %in% colnames(mcols(bins)) && !is.vector(mcols(bins)[[f]]))
      mcols(bins)[[f]] <- CharacterList(mcols(bins)[[f]])
  }
  if(is(bins$tx_biotype,"AtomicList")){
    bins$type[!any(bins$tx_biotype=="protein_coding")] <- "non-coding"
  }

  bins <- sort(bins, by=~gene)
  bins$bin_id <- ave(as.character(strand(bins)),bins$gene,FUN=function(x){
    res<-seq_along(x)
    if(x[1]=="-"){
      res<-rev(res)
    }
    return(res)
  })
  names(bins)<-NULL

  for(f in c("gene_biotype", "tx_biotype")){
    if(f %in% colnames(mcols(bins)))
      mcols(bins)[[f]] <- FactorList(mcols(bins)[[f]])
  }
  for(f in c("tx", "gene")){
    if(f %in% colnames(mcols(bins)))
      mcols(bins)[[f]] <- as.factor(mcols(bins)[[f]])
  }

  o <- findOverlaps(bins, ignore.strand=!stranded)
  o <- o[from(o) %in% unique(from(o)[duplicated(from(o))])]
  ga <- rowsum(as.integer(bins$gene[from(o)] != bins$gene[to(o)]), from(o))
  bins$geneAmbiguous <- FALSE
  bins$geneAmbiguous[as.integer(row.names(ga))] <- ga[,1]>0

  bins
}

#' @importFrom ensembldb genes cdsBy exons
.prepGeneAnno <- function(g, verbose=TRUE){
  if(is.character(g) && length(g)==1) {
    if (grepl("\\.gtf$", g)) {
      g <- rtracklayer::import(g)
    }else{
      stop("Annotation needs to be provided as gtf")
    }
  }

  if(isEnsDb <- is(g,"EnsDb")){
    if(verbose) message("Extracting exon information from EnsDb")
    e <- exons(g, c("exon_id","tx_id","gene_id","gene_name",
                        "gene_biotype","tx_biotype"))
    e$type <- "exon"
    cd <- unlist(cdsBy(g,
                       columns=c("tx_id","tx_biotype","gene_id","gene_name")))
    cd$type <- "CDS"
    g <- genes(g, c("gene_id","gene_name"))
    g$type <- "gene"
    g <- sort(c(g,e,cd))
    rm(e,cd)
  }
  if(!is(g,"GRanges")) stop("Annotation is not valid.")

  synonyms <- list( type="type",
                    tx=c("tx_id","tx_name","transcript","transcript_id",
                         "transcript_name","tx"),
                    gene=c("gene_id","gene","gene_name","gene_symbol",
                           "symbol"),
                    tx_biotype=c("tx_biotype","transcript_biotype",
                                 "transcript_type"),
                    gene_biotype=c("gene_biotype","gene_type"))
  for(f in names(synonyms)){
    ff <- intersect(synonyms[[f]], colnames(mcols(g)))
    if(length(ff)==0) stop(f," information not present!")
    mcols(g)[[f]] <- mcols(g)[[ff[1]]]
    if(f!=ff[1]) mcols(g)[[ff[[1]]]] <- NULL
  }

  if(!isEnsDb){
    if(!any(g$type=="gene") && any(g$type=="transcript")){
      if(!is.factor(g$type)) g$type <- as.factor(g$type)
      levels(g$type) <- unique(levels(g$type), "gene")
      # build the gene entries
      g2 <- g[g$type=="transcript"]
      ff <- c("tx","tx_biotype")
      ff <- intersect(unique(c(ff,unlist(synonyms[ff]))), colnames(mcols(g2)))
      for(f in ff) mcols(g2)[[f]] <- NA
      g2$type <- "gene"
      gmc <- mcols(g2)[!duplicated(g2$gene),]
      row.names(gmc) <- gmc$gene
      g3 <- unlist(reduce(split(g2, g2$gene)))
      mcols(g3) <- gmc[names(g3),]
      g <- c(g,g3)
    }
    g <- g[g$type %in% c("gene", "exon", "CDS")]
    g$type <- droplevels(g$type)
  }
  g
}

.prepAPA <- function(apa, removeAntisense=TRUE){
  if(is.character(apa) && length(apa)==1) {
    if(grepl("\\.rds$", apa)) {
      apa <- readRDS(apa)
      if(!is(apa, "GRanges")) stop("If a RDS file, apa should be a GRanges")
    }else if(grepl("\\.bed$|\\.bed.gz$", apa)){
      apa <- tryCatch(rtracklayer::import.bed(apa), error=function(e){
        extraColvect <- c(percentage="numeric", numberofprot="integer",
                          tpm2="numeric",encod="character",addinfo="character")
        rtracklayer::import(apa, format="bed", extraCols=extraColvect)
      })
    }
  }else if (!is(apa, "GRanges")) {
    stop("Annotation has to be provided as GRanges or bed")
  }
  if("encod" %in% colnames(mcols(apa)))
    apa <- apa[!(apa$encod %in% c("AE","AI","AU"))]
  apa
}

#' @importFrom GenomicRanges width
#' @importFrom IRanges IRanges
.extendWithAPA <- function(g, APA, maxUTRbinSize=15000){
  # get regions which could be boundrys for bins
  gtf1<-g[g$type %in% c("gene", "exon"),]
  #resize gene to 1 as only start of a gene would be a boundry
  gtf1[gtf1$type=="gene",]<-resize(gtf1[gtf1$type=="gene",],1)

  # get regions which could be boundrys for bins

  #seperate by strand because of slightly different syntax
  APAplus<-APA[(as.character(strand(APA))=="+")]
  APAminus<-APA[(as.character(strand(APA))=="-")]

  # find boundry region before each APA site...some have none,
  # so ignore these and do it again
  outmin<-follow(APAminus, gtf1)
  APAminus<-APAminus[is.na(outmin)==FALSE]
  outmin<-follow(APAminus, gtf1, select="all")
  APAminus<-APAminus[from(outmin)]

  outplus<-follow(APAplus, gtf1)
  APAplus<-APAplus[is.na(outplus)==FALSE]
  outplus<-follow(APAplus, gtf1, select="all")
  APAplus<-APAplus[from(outplus)]


  minusranges<-gtf1[to(outmin),]
  plusranges<-gtf1[to(outplus),]

  #create regions from boundry to APA and include metadata

  beginplusbin<-end(plusranges)+1
  endplusbin<-end(APAplus)

  beginminusbin<-start(APAminus)
  endminusbin<-start(minusranges)-1

  plusbin<-GRanges(seqnames=seqnames(plusranges),
                   IRanges(start=beginplusbin, end=endplusbin),
                   strand=as.character(strand(plusranges)))

  minusbin<-GRanges(seqnames=seqnames(minusranges),
                    IRanges(start=beginminusbin, end=endminusbin),
                    strand=as.character(strand(minusranges)))
  mcols(plusbin)<-mcols(plusranges)
  mcols(minusbin)<-mcols(minusranges)

  #merge all regions necessary for differential analysis
  a <- c(plusbin,minusbin)
  a$type<-"UTR"
  #threshold
  a <- a[GenomicRanges::width(a)<maxUTRbinSize,]

  b <- GenomicRanges::setdiff(g[g$type=="exon"], g[g$type=="CDS"])

  o<-as(findOverlaps(b,g[g$type=="exon"]),"List")
  ex<-extractList(mcols(g[g$type=="exon"]), o)
  b <- rep(b, lengths(o))
  mcols(b)<-unlist(ex)
  if(is.factor(b$type)) levels(b$type) <- unique(c(levels(b$type),"UTR"))
  b$type[b$tx_biotype=="protein_coding"] <- "UTR"
  b<-c(b,g[g$type=="CDS"])
  # #b$type[b$type=="CDS"]<-"exon"

  cds<-g[g$type=="CDS"]

  a<-a[!is.na(a$tx)]

  cdsminus<-cds[as.character(strand(cds))=="-",]
  cdsplus<-cds[as.character(strand(cds))=="+",]

  #split by transcripts
  cdsplus<- split(cdsplus, cdsplus$tx)
  cdsminus<- split(cdsminus, cdsminus$tx)

  #find direct index of the last cds of each transcript and get them
  l<-elementNROWS(cdsplus)
  l<-cumsum(l)
  lastcdsplus<-unlist(sort(cdsplus))[l,]

  l<-elementNROWS(cdsminus)
  l<-cumsum(l)-l+1
  lastcdsminus<-unlist(sort(cdsminus))[l,]
  lastCDS<-c(lastcdsminus,lastcdsplus)

  end<-data.frame(tx=lastCDS$tx,end=end(lastCDS))
  end$end[as.character(strand(lastCDS))=="-"] <-
    start(lastCDS)[as.character(strand(lastCDS))=="-"]

  a <- c(a,b)
  o <- order(a$tx)
  a<-a[o,]
  o <- order(end$tx)
  end<-end[o,]

  tx.with.cds <- a$tx %in% end$tx

  tx.nexons <- rowsum(rep(1,length(a$tx[tx.with.cds])),
                      group=a$tx[tx.with.cds], reorder = FALSE)
  ntx <- length(unique(end$tx))
  tidx <- rep(seq_len(ntx), times=tx.nexons)
  a$type <- as.character(a$type)

  # UTR that is 3'

  nocds<-a[!tx.with.cds]
  a<-a[tx.with.cds]
  a$type[a$type=="UTR" & as.character(strand(a))=="+" &
           end$end[tidx]<start(a)]<-"3UTR"
  a$type[a$type=="UTR" & as.character(strand(a))=="-" &
           end$end[tidx]>end(a)]<-"3UTR"
  c(a,nocds)
}

.disjoinGeneWise <- function(a){
  #disjoin them to counting bins
  a<-split(a,a$gene)
  #disjoin them to counting bins
  bins<-disjoin(a,with.revmap=TRUE)

  #reverse mapping indexes are indexes of the corresponding list not of the
  #unlisted bins, so find the length of all sublists
  #for each sublist find the total number of previous features
  g<-cumsum(c(0,head(lengths(a),-1)))

  #this needs to be added to every revmap index of features that were created
  #from this sublist, so expand by the number of features

  adder<-rep(g,lengths(bins))
  bins<-unlist(bins)

  #and as there are list of indexes, expand by the number of indexes
  adder<-rep(adder,lengths(bins$revmap))
  trueidx<-unlist(bins$revmap)+adder

  #get back metadata, tx_name as string with name of each overlapping tx
  #name seperated by + gene_id as List of all genes overlapping this bin
  #type as string: with types overlapping this bin sperated by +
  #booltype->is utr or not


  # for each bin create as many slots as there were overlapping regions and
  # give them the index of the bin
  f <- rep(seq_along(bins), lengths(bins$revmap))

  #put the overlapping regions in to the slots and split them as list by the
  #index (bin they belong to), apply sort and unique in order to only get the
  #metadata once
  mcols(bins) <- DataFrame(lapply( mcols(unlist(a))[trueidx,],
                                FUN=function(x){
                                  sort(unique(splitAsList(x,f)))
                                }))
  bins
}

#' countFeatures
#'
#' @param bamfiles A vector of paths to bam files
#' @param bins A GRanges of bins in which to count reads (or path to a rds file
#' containing such an object
#' @param strandSpecific Passed to `Rsubread::featureCounts`
#' @param readLength Used as a minimum width to estimate read density.
#' @param allowMultiOverlap Passed to `Rsubread::featureCounts`
#' @param inclNormalized Logical; whether to include normalized assays (needed
#' for plotting)
#' @param tmpDir Passed to `Rsubread::featureCounts`
#' @param ... Passed to `Rsubread::featureCounts`
#'
#' @return A \link[SummarizedExperiment]{RangedSummarizedExperiment-class}
#' @import SummarizedExperiment GenomicRanges
#' @importFrom Rsubread featureCounts
#' @importFrom edgeR DGEList cpm calcNormFactors
#' @export
#' @examples
#' data("example_gene_annotation", package="diffUTR")
#' bins <- prepareBins(example_gene_annotation)
#' bam_files <- list.files(system.file("extdata", package="diffUTR"),
#'                         pattern="bam$", full=TRUE)
#' # not run
#' # se <- countFeatures(bam_files, bins, verbose=FALSE)
countFeatures <- function(bamfiles, bins, strandSpecific=0, readLength=50L,
                          allowMultiOverlap=TRUE, inclNormalized=TRUE,
                          tmpDir=tempdir(), ...){
  if(is.character(bins) && length(bins)==1 && grepl("\\.rds$", bins)){
    bins <- readRDS(bins)
  }
  if(!is(bins, "GRanges")) stop("Bins have to be provided as a GRanges")

  if(is.null(names(bins))) names(bins) <- paste(bins$gene,bins$bin_id,sep=".")
  binsframe<-as.data.frame(bins)
  names(binsframe)[names(binsframe) == "seqnames"] <- "Chr"
  binsframe$GeneID <- names(bins)

  if(is.null(names(bamfiles))) names(bamfiles) <- .cleanNames(bamfiles)

  hits <- Rsubread::featureCounts( bamfiles, ..., tmpDir=tmpDir,
                                   annot.ext=binsframe,
                                   isGTFAnnotationFile=FALSE,
                                   strandSpecific=strandSpecific,
                                   allowMultiOverlap=allowMultiOverlap,
                                   useMetaFeatures=FALSE )
  se <- SummarizedExperiment(list(counts=as.matrix(hits$counts)),
                             rowRanges=bins)
  colnames(se) <- names(bamfiles)
  wi <- pmax(width(se),readLength)
  if(ncol(se)==1){
    assays(se)$logcpm <- log1p(assay(se)*10^6/sum(as.numeric(assay(se))))
  }else{
    assays(se)$logcpm <- log1p(cpm(calcNormFactors(DGEList(assay(se)))))
  }
  assays(se)$logNormDensity <- log1p(exp(assays(se)$logcpm)/wi)
  rowData(se)$meanLogCPM <- rowMeans(assays(se)$logcpm)
  rowData(se)$logWidth <- log1p(width(se))
  rowData(se)$meanLogDensity <- rowMeans(assays(se)$logNormDensity)
  rowData(se)$logDensityRatio <- 
    log(.getDensityRatio(rowData(se)$meanLogDensity, rowData(se)$gene))
  colData(se)$assigned <- as.numeric(hits$stat[1,-1,drop=FALSE])
  colData(se)$unassigned <- colSums(hits$stat[-1,-1,drop=FALSE])
  if(!inclNormalized) assays(se) <- assays(se)[1]
  se
}

#' simesAggregation
#'
#' Simes p-value correction and aggregation, adapted from
#' \code{link[limma]{diffSplice}}
#'
#' @param p.value A vector of p-values
#' @param geneid A vector of group labels such as gene identifiers
#'
#' @return A named vector of aggregated p-values
#' @export
#'
#' @examples
#' p <- runif(50)
#' genes <- sample(LETTERS,50,replace=TRUE)
#' simesAggregation(p, genes)
simesAggregation <- function(p.value, geneid){
  stopifnot(is.numeric(p.value))
  stopifnot(length(p.value)==length(geneid))
  o <- order(geneid)
  geneid <- geneid[o]
  p.value <- p.value[o]

  ngenes <- length(unique(geneid))

  gene.nexons <- rowsum(rep(1,length(p.value)), geneid, reorder=FALSE)
  g <- rep(seq_len(ngenes), times=gene.nexons)

  gene.lastexon <- cumsum(gene.nexons)
  gene.firstexon <- gene.lastexon-gene.nexons+1

  penalty <- rep_len(1L,length(g))
  names(p.value)<-geneid
  penalty[gene.lastexon] <- 1L-gene.nexons
  penalty <- cumsum(penalty)[-gene.lastexon]
  penalty <- penalty / rep(gene.nexons-1L,gene.nexons-1L)
  g2 <- g[-gene.lastexon]

  gene.simes.p.value <- rep(1, length(gene.nexons))

  o <- order(g,p.value)
  p.adj <- pmin(p.value[o][-gene.lastexon] / penalty, 1)
  o <- order(g2,p.adj)
  gene.simes.p.value <- p.adj[o][gene.firstexon-0L:(ngenes-1L)]

  gene.simes.p.value
}

#' geneLevelStats
#'
#' Aggregates bin-level statistics to the gene-level
#'
#' @param se A `RangedSummarizedExperiment` containing the results of one of
#' the DEU wrappers.
#' @param coef The coefficients tested (if the model included more than one
#' term).
#' @param excludeTypes Vector of bin types to exclude.
#' @param includeTypes Vector of bin types to include (overrides
#' `excludeTypes`)
#' @param minDensityRatio Minimum ratio of read density (with respect to the 
#' gene's average) for a bin to be included.
#' @param minWidth Minimum bin width to include
#' @param excludeGeneAmbiguous Logical; whether to exclude bins which are 
#' ambiguous (i.e. can be from different genes)
#' @param returnSE Logical; whether to return the updated `se` object
#' (default), or the gene-level table.
#'
#' @return If `returnSE=TRUE` (default), returns the `se` object with an
#' updated `metadata(se)$geneLevel` slot, otherwise returns the gene-level
#' data.frame.
#' @export
#'
#' @import S4Vectors
#' @importFrom stats weighted.mean
#' @examples
#' library(SummarizedExperiment)
#' data(example_bin_se)
#' se <- diffSpliceWrapper(example_bin_se, ~condition)
#' se <- geneLevelStats(se, includeTypes="3UTR")
#' head(metadata(se)$geneLevel)
geneLevelStats <- function(se, coef=NULL, excludeTypes=NULL, includeTypes=NULL,
                           returnSE=TRUE, minDensityRatio=0.1, minWidth=20,
                           excludeGeneAmbiguous=TRUE){
  rd <- rowData(se)
  if(is.null(rd$logDensityRatio))
    rd$logDensityRatio <- log(.getDensityRatio(rd$meanLogDensity, rd$gene))
  
  rd$width <- GenomicRanges::width(se)
  rd <- rd[rd$logDensityRatio > log(minDensityRatio) & rd$width >= minWidth,]
  if(excludeGeneAmbiguous) rd <- rd[!rd$geneAmbiguous,]
  
  if(!is.null(includeTypes)){
    excludeTypes <- setdiff(levels(rd$type), includeTypes)
  }
  if(!is.null(excludeTypes)){
    rd$bin.p.value[which(rd$type %in% excludeTypes)] <- 1
  }
  if(is.null(coef)){
    tmp <- setdiff(colnames(rd),"exonBaseMean")
    coef <- colnames(rd)[grep("bin.p.value",tmp)-1]
  }
  metadata(se)$geneLevel <- .geneLevelStats(DataFrame(
    bin.pval=rd$bin.p.value, coef=rd[[coef]], width=rd$width,
    gene=rd$gene, gene_name=rd$gene_name, meanLogDensity=rd$meanLogDensity,
    logDensityRatio=rd$logDensityRatio))

  if(!returnSE) return(metadata(se)$geneLevel)
  se
}

#' @importFrom methods is as
#' @importFrom IRanges LogicalList NumericList IntegerList mean
.geneLevelStats <- function(d, gene.qval=NULL){
  stopifnot(c("bin.pval","coef","gene","width","meanLogDensity","logDensityRatio") 
              %in% colnames(d))
  d$bin.pval[is.na(d$bin.pval)] <- 1
  if(is.null(gene.qval)) gene.qval <- simesAggregation(d$bin.pval, d$gene)
  d$gene <- droplevels(as.factor(d$gene))
  d$coef[is.na(d$coef)] <- 0
  d$weight <- -log10(d$bin.pval)-0.5
  d$weight[is.na(d$weight) | d$weight<0] <- 0
  w <- NumericList(split(d$weight, d$gene))
  ws <- sum(w)
  ww <- which(ws>0)
  w[ww] <- w[ww]/ws[ww]
  ww <- which(!(ws>0))
  g0 <- names(ws[ww])
  co <- NumericList(split(d$coef, d$gene))
  wi <- IntegerList(split(sqrt(d$width), d$gene))
  de <- NumericList(split(d$meanLogDensity, d$gene))
  dr <- NumericList(split(exp(d$logDensityRatio), d$gene))
  d2 <- data.frame( row.names = names(co),
                    nb.bins = lengths(co),
                    w.coef=sum(w*co),
                    w.abs.coef=sum(w*abs(co)),
                    w.sqWidth=sum(w*wi),
                    w.density=log2(sum(w*de)),
                    sizeScore=sum(wi/sum(wi)*w*co),
                    abs.sizeScore=sum(wi/sum(wi)*w*abs(co)),
                    geneMeanDensity=mean(de,trim=0.05, na.rm=TRUE) )
  d2[g0,c(3:8)] <- 0
  d2$density.ratio <- sum(w*dr)

  for(f in c(1:2,5:8)) d2[,f] <- round(d2[,f],3)
  d2$w.sqWidth <- as.integer(round(d2$w.sqWidth))
  d2$q.value <- gene.qval[row.names(d2)]
  if("gene_name" %in% colnames(d)){
    d <- d[order(d$gene, lengths(d$gene_name)),c("gene","gene_name")]
    d <- d[!duplicated(d$gene),]
    row.names(d) <- d$gene
    if(is(d$gene_name,"FactorList"))
      d$gene_name <- as(d$gene_name, "CharacterList")
    if(is(d$gene_name,"CharacteList")){
      d$name <- unstrsplit(d$gene_name, sep = "/")
    }else{
      d$name <- d$gene_name
    }
    d$name <- unstrsplit(d$gene_name, sep = "/")
    d2 <- merge(d[,"name",drop=FALSE], d2, by="row.names")
    row.names(d2) <- d2$Row.names
    d2 <- d2[,-1]
  }
  d2[order(d2$q.value),]
}

#' DEUwrappers
#'
#' Wrappers around commonly-used DEU methods
#' (\code{\link[edgeR]{diffSpliceDGE}}, \code{\link[DEXSeq]{DEXSeq}} and an
#' improved version of \code{\link[limma]{diffSplice}}
#'
#' @param se A bin-wise SummarizedExperiment as produced by
#' \code{\link{countFeatures}}
#' @param design A formula (using columns of `colData(se)`) or (for
#' `diffSpliceWrapper` or `diffSpliceDGEWrapper` only) a model.matrix.
#' @param reducedModel A reduced formula (applicable only to `DEXSeqWrapper`).
#' @param coef The coefficient to be tested (ignored for `DEXSeqWrapper`).
#' @param QLF Logical; whether to use edgeR's quasi-likelihood negative
#' binomial (applicable only to `diffSpliceDGEWrapper`).
#' @param robust Logical; whether to use robust fitting for the dispersion
#' trend (ignored for `DEXSeqWrapper`).
#' @param countFilter Logical; whether to filter out low-count bins (ignored
#' for `DEXSeqWrapper`).
#' @param excludeTypes A vector of bin types to ignore for testing. To test
#' for any kind of differential usage, leave empty. To test for differential
#' UTR usage, use `excludeTypes=c("CDS","non-coding")` (or see
#'  \code{\link{geneLevelStats}} for more options).
#'
#' @return The `se` object with additional rowData columns contain bin (i.e.
#' exon) -level statistics, and a metadata slot containing gene level p-values.
#'
#' @importFrom edgeR DGEList calcNormFactors glmQLFit glmFit diffSpliceDGE
#' @importFrom edgeR filterByExpr estimateDisp
#' @importFrom stats p.adjust setNames
#' @importFrom matrixStats rowMins
#' @aliases DEUwrappers
#' @export
#' @rdname DEUwrappers
#' @examples
#' library(SummarizedExperiment)
#' data(example_bin_se)
#' se <- diffSpliceWrapper(example_bin_se, ~condition)
#' head(rowData(se))
diffSpliceDGEWrapper <- function(se, design, coef=NULL, QLF=TRUE, robust=TRUE,
                                  countFilter=TRUE, excludeTypes=NULL){
  se <- .checkSE(se)
  if(is(design, "formula"))
    design <- model.matrix(design, data=as.data.frame(colData(se)))
  if(is.null(coef)){
    coef <- ifelse(is.null(colnames(design)), ncol(design),
                   rev(colnames(design))[1])
    message("Testing coefficient ", coef)
  }
  if(countFilter) se <- se[filterByExpr(assays(se)$counts, design=design),]
  dds <- calcNormFactors(DGEList(assays(se)$counts))
  dds <- estimateDisp(dds,design)
  if(QLF){
    fit <- glmQLFit(dds, design, robust=robust)
  }else{
    fit <- glmFit(dds, design, robust=robust)
  }
  res <- diffSpliceDGE(fit, coef=coef, geneid=rowData(se)$gene,
                       exonid=row.names(se))
  se <- se[names(res$exon.p.value),]
  co <- res$coefficients
  if(!is.null(dim(co))) co <- co[,coef]
  if(length(coef)>1 && !is.null(dim(res$exon.p.value))){
    rowData(se) <- cbind(rowData(se), co)
    pv <- res$exon.p.value[,coef]
    colnames(pv) <- paste0(colnames(pv),".p.value")
    rowData(se)$coefficient <- mapply(i=seq_len(nrow(co)),
                                      j=apply(pv,1,which.min),
                                      FUN=function(i,j) co[i,j])
    rowData(se) <- cbind(rowData(se), pv)
    rowData(se)$bin.p.value <- ep <- rowMins(pv)
  }else{
    rowData(se)$coefficient <- co
    rowData(se)$bin.p.value <- ep <- res$exon.p.value
  }

  if(!is.null(excludeTypes)) ep[rowData(se)$type %in% excludeTypes] <- 1
  rowData(se)$bin.FDR <- p.adjust(ep)

  geneLevelStats(se, coef="coefficient", excludeTypes=excludeTypes)
}

#' @param improved Logical; whether to use \code{\link{diffSplice2}} instead
#' of the original \code{\link[limma]{diffSplice}} (default TRUE).
#' @importFrom stats model.matrix
#' @importFrom limma lmFit voom diffSplice
#' @importFrom edgeR DGEList calcNormFactors filterByExpr
#' @export
#' @rdname DEUwrappers
diffSpliceWrapper <- function(se, design, coef=NULL, robust=TRUE,
                               improved=TRUE, countFilter=TRUE,
                               excludeTypes=NULL){
  se <- .checkSE(se)
  if(is(design, "formula"))
    design <- model.matrix(design, data=as.data.frame(colData(se)))
  if(is.null(coef)){
    coef <- ifelse(is.null(colnames(design)), ncol(design),
                   rev(colnames(design))[1])
    message("Testing coefficient ", coef)
  }

  if(countFilter) se <- se[filterByExpr(assays(se)$counts, design=design),]
  dds <- calcNormFactors(DGEList(assays(se)$counts))
  dds <- voom(dds, design)
  dds <- lmFit(dds, design)

  if(improved){
    res <- diffSplice2(dds, geneid=rowData(se)$gene, exonid=row.names(se),
                       robust=robust)
  } else{
    res <- diffSplice(dds, geneid=rowData(se)$gene, exonid=row.names(se),
                      robust=robust)
  }

  se <- se[row.names(res$p.value),]

  tmp <- rowData(se)[,setdiff(colnames(rowData(se)),
                    c(colnames(res$coefficients),"bin.p.value","coefficient"))]
  if(length(coef)>1){
    co <- res$coefficients[,coef]
    pv <- res$p.value[,coef]
    colnames(pv) <- paste0(colnames(pv),"p.value")
    tmp$coefficient <- mapply(i=seq_len(nrow(co)), j=apply(pv,1,which.min),
                                      FUN=function(i,j) co[i,j])
    tmp <- cbind(tmp, co, pv)
    ep <- rowMins(pv)
  }else{
    tmp$coefficient <- res$coefficients[,coef]
    ep <- res$p.value[,coef]
  }
  tmp$bin.p.value <- ep
  rowData(se) <- tmp
  rowData(se)$bin.FDR <- p.adjust(ep)

  geneLevelStats(se, coef="coefficient", excludeTypes=excludeTypes)
}

#' @param ... Further arguments (passed to `testForDEU` and
#' `estimateExonFoldChanges`) of `DEXSeq`. Can for instance be used to enable 
#' multithreading, by passing `BPPARAM=BiocParallel::MulticoreParam(ncores)`.
#' @importFrom DEXSeq DEXSeqDataSet estimateSizeFactors estimateDispersions
#' @importFrom DEXSeq estimateExonFoldChanges DEXSeqResults perGeneQValue
#' @importFrom DEXSeq testForDEU
#' @export
#' @rdname DEUwrappers
DEXSeqWrapper <- function(se, design=~sample+exon+condition:exon,
                           reducedModel=~sample+exon, excludeTypes=NULL, ...){
  if(!("exon" %in% labels(terms(design))))
    stop("For DEXSeq, the formula should include the extra 'sample' and ",
         "'exon' terms.\nFor instance, if you wanted to test for an effect ",
         "of the variable 'condition' on bin usage, you would use:\n",
         "~sample+exon+condition:exon")
  se <- .checkSE(se)
  e <- floor(as.matrix(assays(se)$counts))
  e <- matrix(as.integer(e), nrow=nrow(e))
  dds <- DEXSeqDataSet(e, sampleData=as.data.frame(colData(se)),
                         design=design, featureRanges=rowRanges(se),
                         featureID=row.names(se), groupID=rowData(se)$gene)
  dds <- estimateSizeFactors( dds )
  dds <- estimateDispersions( dds )
  dds <- testForDEU( dds, reducedModel=reducedModel,...)
  vars <- setdiff(labels(terms(design)), labels(terms(reducedModel)))
  vars <- gsub(":exon|exon:", "", grep(":exon|exon:", vars, value=TRUE))
  dds <- estimateExonFoldChanges( dds, fitExpToVar=vars, ... )
  res <- DEXSeqResults( dds )

  rowData(se)$log2fc <- res[[rev(grep("log2fold",names(res)))[1]]]
  rowData(se)$exonBaseMean <- res$exonBaseMean
  rowData(se)$bin.p.value <- res$pvalue

  if(!is.null(excludeTypes))
    res$pvalue[rowData(se)$type %in% excludeTypes] <- 1
  rowData(se)$bin.FDR <- p.adjust(res$pvalue)

  message("Generating gene-level stats...")

  d <- DataFrame(bin.pval=res$pvalue, coef=rowData(se)$log2fc,
                 gene=rowData(se)$gene, width=width(se),
                 meanLogDensity=rowData(se)$meanLogDensity,
                 logDensityRatio=rowData(se)$logDensityRatio)
  if("gene_name" %in% colnames(rowData(se)))
    d$gene_name <- rowData(se)$gene_name
  
  metadata(se)$geneLevel <- .geneLevelStats(d=d, gene.qval=perGeneQValue(res))
  se
}

#' @rdname example_bin_se
#' @name example_bin_se
#' @aliases example_bin_se
#'
#' @title Example bin-level `RangedSummarizedExperiment`
#'
#' @description
#' An object produced by \code{\link{countFeatures}} containing small subset of
#'  genes from mouse hippocampal slices undergoing Forskolin-induced long-term
#' potentiation (GSE84643).
#'
#' @return a `RangedSummarizedExperiment`
#' @references \url{https://www.nature.com/articles/s41598-017-17407-w}
NULL

#' @rdname example_gene_annotation
#' @name example_gene_annotation
#' @aliases example_gene_annotation
#'
#' @title Example gene annotation
#'
#' @description
#' An example gene annotation containing only a small subset of mouse genes.
#'
#' @return a `GRanges` object
NULL

#' @rdname rn6_PAS
#' @name rn6_PAS
#' @aliases rn6_PAS
#'
#' @title Poly-A sites compendium for Rattus Norvegicus (Rno6)
#'
#' @description
#' These are the sites from polyA_DB release 3.2, downloaded from
#' \url{https://exon.apps.wistar.org/PolyA_DB/v3/download/3.2/rat_pas.zip},
#' and lifted over to Rno6.
#'
#' @return a `GRanges` object
NULL

#' geneBinHeatmap
#'
#' A wrapper around `ComplexHeatmap`.
#'
#' @param se A bin-wise SummarizedExperiment as produced by
#' \code{\link{countFeatures}}
#' @param gene The gene of interest
#' @param what Type of values (i.e. assay) to plot
#' @param minDensityRatio Minimum ratio of read density (with respect to the 
#' gene's average) for a bin to be plotted.
#' @param anno_rows Row annotation columns (i.e. columns of `rowData(se)`) to
#' plot
#' @param anno_columns Column annotation columns (i.e. columns of
#' `colData(se)`) to plot
#' @param anno_colors Annotation colors, as a list named with the row/column
#' annotations, see `\code{\link[ComplexHeatmap]{SingleAnnotation}}` for
#' details. Ignored if `left_annotation` and/or `top_annotation` are given
#' directly.
#' @param removeAmbiguous Logical; whether to remove bins that are
#' gene-ambiguous (i.e. overlap multiple genes).
#' @param merge_legends Logical; whether to merge legends. This effectively
#' calls `draw(..., merge_legends=TRUE)` around the heatmap.
#' @param cluster_columns Logical; whether to cluster columns (passed to
#' \code{\link[ComplexHeatmap]{Heatmap}})
#' @param left_annotation Passed to \code{\link[ComplexHeatmap]{Heatmap}},
#' overrides `anno_rows`.
#' @param top_annotation Passed to \code{\link[ComplexHeatmap]{Heatmap}},
#' overrides `anno_columns`.
#' @param ... Passed to `ComplexHeatmap` (see
#' \code{\link[ComplexHeatmap]{Heatmap}})
#'
#' @return A \code{\link[ComplexHeatmap]{Heatmap}}
#' @export
#' @import SummarizedExperiment
#' @importFrom ComplexHeatmap draw Heatmap HeatmapAnnotation rowAnnotation
#' @importFrom viridisLite viridis
#'
#' @examples
#' data(example_bin_se)
#' se <- diffSpliceWrapper(example_bin_se, ~condition)
#' geneBinHeatmap(se, "Jund")
geneBinHeatmap <- function(se, gene,
                           what=NULL,
                           anno_rows=c("type","logWidth","meanLogDensity",
                                       "log10PValue","geneAmbiguous"),
                           anno_columns=c(), anno_colors=list(),
                           removeAmbiguous=FALSE, merge_legends=TRUE,
                           cluster_columns=FALSE, minDensityRatio=0.1,
                           left_annotation=NULL, top_annotation=NULL, ...){
  se <- .checkSE(se, checkNorm=TRUE)
  if(length(w <- .matchGene(se, gene))==0) stop("Gene not found!")
  se <- sort(se[w,])
  if(removeAmbiguous) se <- se[!rowData(se)$geneAmbiguous,]
  se <- se[rowData(se)$logDensityRatio >= log(minDensityRatio),]
  if(is.null(what)){
    h1 <- geneBinHeatmap(se, gene, "logNormDensity", anno_rows=anno_rows,
                         anno_columns=anno_columns, anno_colors=anno_colors,
                         removeAmbiguous=removeAmbiguous, merge_legends=FALSE,
                         left_annotation=left_annotation, col=viridis(20),
                         column_title="logNormDensity",
                         top_annotation=top_annotation, ...)
    h2 <- geneBinHeatmap(se, gene, "scaledLogCPM", anno_rows=c(),
                         anno_columns=anno_columns, anno_colors=anno_colors,
                         removeAmbiguous=removeAmbiguous, merge_legends=FALSE,
                         column_title="scaledLogCPM",
                         top_annotation=top_annotation, ...)
    if(merge_legends) return(draw(h1+h2, merge_legends=TRUE))
    return(h1+h2)
  }else{
    what <- match.arg(what, c("logNormDensity", "logCPM", "scaledLogCPM"))
  }
  if("log10PValue" %in% anno_rows &&
     !("log10PValue" %in% colnames(rowData(se))))
    rowData(se)[["log10PValue"]] <- -log10(rowData(se)$bin.p.value)
  if("type" %in% anno_rows && is.null(anno_colors$type))
    anno_colors$type <- .typeColors()
  if(removeAmbiguous | !any(rowData(se)$geneAmbiguous))
    anno_rows <- intersect(setdiff(anno_rows, "geneAmbiguous"),
                           colnames(rowData(se)))
  if(is.null(left_annotation) && length(anno_rows)>0){
    left_annotation <- rowAnnotation(
      df=as.data.frame(rowData(se)[,anno_rows,drop=FALSE]),
      col=anno_colors[intersect(names(anno_colors),anno_rows)])
  }
  if(is.null(top_annotation) && !is.null(anno_columns)){
    top_annotation <- HeatmapAnnotation(
      df=as.data.frame(colData(se)[,anno_columns,drop=FALSE]),
      col=anno_colors[intersect(names(anno_colors),anno_rows)])
  }
  x <- assays(se)[[ifelse(what=="logNormDensity",what,"logcpm")]]
  if(what=="scaledLogCPM") x <- t(scale(t(x)))
  h <- Heatmap(x, name=what, show_row_names=FALSE, cluster_rows=FALSE,
          cluster_columns=cluster_columns, row_title=paste(gene, "bins"),
          top_annotation=top_annotation, left_annotation=left_annotation, ...)
  if(merge_legends) return(draw(h, merge_legends=TRUE))
  h
}

#' deuBinPlot
#'
#' @param se A bin-wise SummarizedExperiment as produced by
#' \code{\link{countFeatures}} and including bin-level tests (i.e. having been
#' passed through one of the DEU wrappers such as
#' \code{\link{diffSpliceWrapper}} or \code{\link{DEXSeqWrapper}})
#' @param gene The gene of interest
#' @param type Either 'summary' (plot DEU summary), 'sample' (plot sample-wise
#' data), or 'condition' (plot data aggregate by condition)
#' @param intronSize Intron plot size. If <=3, intron size will be this
#' fraction of the mean exon size. If >3, each intron will have the given size.
#' @param exonSize Scaling for exon sizes, either 'sqrt', 'log', or 'linear'.
#' @param y Value to plot on the y-axis. If `type="summary"`, this should be a
#' column of `rowData(se)`, otherwise should be an assay name of `se`.
#' @param condition The colData column containing the samples' condition.
#' @param size rowData variable to use to determine the thickness of the bins.
#' @param lineSize Size of the line connecting the bins. Use `lineSize=0` to
#' omit the line.
#' @param colour rowData variable to use to determine the colour of the bins.
#' If `type="condition"`, can also be "condition"; if `type="sample"` can be
#' any colData column.
#' @param alpha Alpha level, passed to ggplot.
#' @param removeAmbiguous Logical; whether to remove bins that are
#' gene-ambiguous (i.e. overlap multiple genes).
#' @param minDensityRatio Minimum ratio of read density (with respect to the 
#' gene's average) for a bin to be plotted.
#'
#' @return A ggplot object
#' @importFrom matrixStats colMedians
#' @importFrom dplyr bind_rows
#' @export
#' @import ggplot2
#'
#' @examples
#' data(example_bin_se)
#' se <- diffSpliceWrapper(example_bin_se, ~condition)
#' deuBinPlot(se, "Jund")
deuBinPlot <- function(se, gene, type=c("summary","condition","sample"),
                       intronSize=2, exonSize=c("sqrt","linear","log"), y=NULL,
                       condition=NULL, size="type", lineSize=1,
                       colour=NULL, alpha=NULL, removeAmbiguous=TRUE,
                       minDensityRatio=0.1){
  se <- .checkSE(se)
  type <- match.arg(type)
  exonSize <- match.arg(exonSize)
  stopifnot(length(gene)==1)
  if(is.null(colour)){
    if(type!="summary" && !is.null(condition)){
      colour <- "condition"
    }else{
      colour <- "log10PValue"
    }
  }
  if(is.null(alpha)) alpha <- ifelse(type=="sample", 0.6, 1)
  w <- .matchGene(se, gene)
  if(length(w)==0) stop("Gene not found in the data!")
  if(type=="condition"){
    if(is.null(condition) && "condition" %in% colnames(colData(se))){
      condition <- "condition"
    }else{
      condition <- "group"
    }
    stopifnot(length(condition)==1 && condition %in% colnames(colData(se)))
  }
  if(is.null(y)){
    if(type=="summary"){
      ff <- colnames(rowData(se))[grep("bin.p.value",colnames(rowData(se)))-1]
      for(f in c("coefficient","coefficients","log2fc","logFC",ff))
        if(is.null(y) && f %in% colnames(rowData(se))) y <- f
      if(is.null(y)) stop("Please specify `y` among the rowData columns.")
    }else{
      if("logNormDensity" %in% assayNames(se)){
        y <- "logNormDensity"
      }else{
        y <- assayNames(se)[1]
        message("Using assay '",y, "' (use `y` to specify another)")
      }
    }
  }

  se <- sort(se[w,])
  if(removeAmbiguous) se <- se[!rowData(se)$geneAmbiguous,]
  se <- se[rowData(se)$logDensityRatio >= log(minDensityRatio),]
  de <- rowData(se)
  if(y=="geneNormDensity" && !("geneNormDensity" %in% assayNames(se))){
    si <- vapply(split(seq_len(ncol(se)), se[[condition]]),
                 FUN.VALUE=numeric(1), FUN=function(i){
                   mean(matrixStats::colMedians(assays(se)$logNormDensity[,i]))
                 })
    assays(se)$geneNormDensity <-
      t(t(assays(se)$logNormDensity)-si[se[[condition]]])
  }

  if(size=="type"){
    levels(de$type)[grepl("CDS/.*UTR", levels(de$type))] <- "CDS/UTR"
    levels(de$type)[grep("CDS/.*UTR", levels(de$type))] <- "CDS/UTR"
    levels(de$type)[grep("CDS|non-coding", levels(de$type), invert=TRUE)] <-
      "UTR"
    de$type <- factor(de$type, c("non-coding","UTR","CDS/UTR","CDS"))
  }

  gr <- ranges(se)
  de$log10PValue <- -log10(de$bin.p.value)
  de$order <- seq_len(nrow(de))
  de$width <- width(gr)
  de$width2 <- switch(exonSize, sqrt=sqrt(de$width), log=log(de$width),
                      de$width)
  de$nextIsIntron <- c(start(gr)[-1],rev(end(gr))[1]) > end(gr)+1
  if(intronSize <= 3) intronSize <- intronSize*mean(de$width2)
  de$x_start <- c(0,cumsum(de$width2)+
                    cumsum(de$nextIsIntron*intronSize))[-nrow(de)]
  de$x_end <- de$x_start + de$width2
  getd2 <- function(de)
    data.frame( x_start=de$x_end[-nrow(de)], x_end=de$x_start[-1],
                y_start=de[[y]][-nrow(de)], y_end=de[[y]][-1],
                type=de$nextIsIntron[-nrow(de)])
  p <- ggplot(as.data.frame(de))
  if(type=="summary"){
    if(lineSize>0){
      d2 <- getd2(de)
      p <- p + geom_segment(data=d2,
                            aes(x=x_start, xend=x_end, y=y_start, yend=y_end,
                                linetype=type),
                            colour="grey", size=lineSize, alpha=alpha)
    }
  }else{
    y <- match.arg(y, assayNames(se))
    if(type=="condition"){
      e <- vapply(split(seq_len(ncol(se)), colData(se)[[condition]]),
                  FUN.VALUE=numeric(nrow(de)),
                  FUN=function(i) rowMeans(assays(se)[[y]][,i,drop=FALSE]))
    }else{
      e <- assays(se)[[y]][,]
    }
    de <- lapply(setNames(colnames(e),colnames(e)), FUN=function(x){
      de2 <- as.data.frame(de)
      de2[[y]] <- as.numeric(e[,x])
      de2
    })
    if(lineSize>0) d2 <- dplyr::bind_rows(lapply(de, FUN=getd2), .id=type)
    de <- dplyr::bind_rows(de, .id=type)
    if(type=="sample"){
      de <- cbind(de, colData(se)[de$sample,,drop=FALSE])
      if(lineSize>0) d2 <- cbind(d2, colData(se)[d2$sample,,drop=FALSE])
    }
    if(type=="sample" && lineSize>0 && colour %in% colnames(d2)){
      p <- p + geom_segment(data=d2,
                          aes_string(x="x_start", xend="x_end", y="y_start",
                                     yend="y_end", linetype="type",
                                     colour=colour),
                          size=lineSize, alpha=min(0.6,alpha))
    }else{
      p <- p + geom_segment(data=d2,
                        aes_string(x="x_start", xend="x_end", y="y_start",
                                   yend="y_end", linetype="type", group=type),
                        colour="grey", size=lineSize, alpha=min(0.6,alpha))
    }
  }
  if(colour=="type" && type!="sample")
    p <- p + scale_colour_manual(values=.typeColors())
  if(size=="type")
    p <- p + scale_size_manual(values=c("non-coding"=2, "UTR"=3, "CDS/UTR"=4,
                                        CDS=6))
  xlab <- switch(exonSize,
                 linear="Genomic location",
                 paste0(exonSize,"-scaled genomic location"))
  p + scale_linetype_manual(values=c("TRUE"="dotted", "FALSE"="solid"),
                            guide=FALSE) +
    geom_segment(data=as.data.frame(de), alpha=alpha,
                 aes_string(x="x_start", xend="x_end", y=y, yend=y, size=size,
                            colour=colour)) +
    theme(axis.text.x=element_blank(), axis.ticks.x=element_blank()) +
    ggtitle(paste0(gene, " (", as.character(strand(se)[1]),")")) + xlab(xlab) +
    ylab(ifelse(y=="geneNormDensity","Gene-normalized logDensity",y))
}


#' plotTopGenes
#'
#' @param se A bin-wise SummarizedExperiment as produced by
#' \code{\link{countFeatures}} and including bin-level tests (i.e. having been
#' passed through one of the DEU wrappers such as
#' \code{\link{diffSpliceWrapper}} or \code{\link{DEXSeqWrapper}})
#' @param n The maximum number of genes for which to plot labels
#' @param FDR The FDR threshold above which to plot labels
#' @param diffUTR Logical; if FALSE, uses absolute coefficients (appropriate
#' for normal differential exon usage); if TRUE, uses non-absolute (ie changes
#' should be in the same direction across significant bins) and width-weighted
#' scores (i.e. larger bins have more weight) -- this is relevant only when
#' testing UTR usage.
#' @param alpha Points transparency
#' @param ... Passed to \link[ggrepel]{geom_label_repel}; this can for instance
#' be used to increase `max.overlaps` when not all desired gene labels are 
#' displayed)
#'
#' @return A ggplot
#' @export
#' @importFrom S4Vectors metadata
#' @import ggplot2
#' @importFrom ggrepel geom_text_repel
#'
#' @examples
#' data(example_bin_se)
#' se <- diffSpliceWrapper(example_bin_se, ~condition)
#' plotTopGenes(se)
plotTopGenes <- function(se, n=10, FDR=0.05, diffUTR=FALSE, alpha=1, ...){
  if(is(se, "SummarizedExperiment")){
    se <- .checkSE(se, requireStats=TRUE)
    se <- metadata(se)$geneLevel
  }
  stopifnot(!is.null(se) && (is.data.frame(se) || is(se,"DFrame")))
  se <- as.data.frame(se[!is.na(se$q.value),])
  if(length(w <- which(se$q.value<=0))>0){
    minnzq <- -log10(min(se$q.value[-w],na.rm=TRUE))
    score <- abs(se[[ifelse(diffUTR,"sizeScore","w.abs.coef")]])
    o <- order(order(score[w]))
    se$q.value[w] <- 10^-(minnzq+o*minnzq/(4*length(w)))
  }
  if(diffUTR){
    if(is.null(alpha)) alpha <- 1
    se$col <- sign(se$sizeScore)
    se$col[is.na(se$col)] <- 0
    p <- ggplot(se, aes(sizeScore, -log10(q.value))) + 
      geom_vline(xintercept=0, linetype="dashed", col="grey") +
      geom_point(aes(colour=log(density.ratio), size=geneMeanDensity), alpha=alpha) +
      xlab("Weighted size score") + scale_colour_viridis_c(direction = -1)
    de <- se[se$q.value<FDR,,drop=FALSE]
    de$tmp <- abs(-log10(de$q.value)*de$sizeScore)
    de$tmp <- -log10(de$q.value)*de$sizeScore/rank(de$q.value)
  }else{
    se$tmp <- -log10(se$q.value)*se$w.abs.coef/rank(se$q.value)
    if(is.null(alpha)){
      p <- ggplot(se, aes(w.abs.coef, -log10(q.value))) +
        geom_point(aes(colour=log(density.ratio), size=geneMeanDensity,
                       alpha=sqrt(sqrt(tmp)))) + scale_alpha(guide=FALSE) +
        scale_colour_viridis_c(direction = -1)

    }else{
      p <- ggplot(se, aes(w.abs.coef, -log10(q.value))) +
        geom_point(aes(colour=log(density.ratio), size=geneMeanDensity),
                   alpha=alpha) + scale_colour_viridis_c(direction = -1)
    }
    p <- p + xlab("Weighted absolute coefficient")
    de <- se[se$q.value<FDR,,drop=FALSE]
  }
  if(n>0){
    de <- de[head(order(-de$tmp),n),,drop=FALSE]
    if(is.null(de$name)) de$name <- row.names(de)
    p <- p + geom_text_repel(data=de, aes(label=name), ...)
  }
  p
}

#' diffSplice2
#'
#' This is a small improvement to the \code{\link[limma]{diffSplice}} function
#' written by Gordon Smyth and Charity Law.
#'
#' @param fit an \code{\link[limma]{MArrayLM-class}} fitted model object
#' produced by \code{\link[limma]{lmFit}} or `contrasts.fit`, with rows
#' corresponding to exons.
#' @param geneid gene identifiers (as in \code{\link[limma]{diffSplice}})
#' @param exonid exon identifiers (as in \code{\link[limma]{diffSplice}})
#' @param robust logical, should the estimation of the empirical Bayes prior
#' parameters be robustified against outlier sample variances?
#' @param verbose logical, if TRUE will output some diagnostic information
#'
#' @return An \code{\link[limma]{MArrayLM-class}} object containing both exon
#' level and gene level tests. Results are sorted by geneid and by exonid
#' within gene.
#' @export
#' @import limma
#' @importFrom methods new
#' @importFrom stats ave pf pt terms
#' @examples
#' library(SummarizedExperiment)
#' library(edgeR)
#' data(example_bin_se)
#' se <- example_bin_se
#' design <- model.matrix(~condition, data=as.data.frame(colData(se)))
#' dds <- calcNormFactors(DGEList(assays(se)$counts))
#' dds <- voom(dds, design)
#' dds <- lmFit(dds, design)
#' res <- diffSplice2(dds, geneid=rowData(se)$gene, exonid=row.names(se))
#' topSplice(res)
diffSplice2 <- function(fit, geneid, exonid=NULL, robust=FALSE, verbose=TRUE){
  # Exon Level squeeze, exon.s2.post t-test and weighting,
  # sum of exon.df as gene.df after squeeze
  exon.genes <- fit$genes
  if(is.null(exon.genes)) exon.genes <- data.frame(ExonID=seq_len(nrow(fit)))

  # Get ID columns for genes and exons
  if(length(geneid)==1) {
    genecolname <- as.character(geneid)
    geneid <- exon.genes[[genecolname]]
  } else {
    exon.genes$GeneID <- geneid
    genecolname <- "GeneID"
  }
  if(is.null(exonid)) {
    exoncolname <- NULL
  } else {
    if(length(exonid)==1) {
      exoncolname <- as.character(exonid)
      exonid <- exon.genes[[exoncolname]]
    } else {
      exon.genes$ExonID <- exonid
      exoncolname <- "ExonID"
    }
  }

  # Treat NA geneids as genes with one exon
  if(anyNA(geneid)) {
    isna <- which(is.na(geneid))
    geneid[isna] <- paste0("NA",seq_along(isna))
  }

  # Sort by geneid
  if(is.null(exonid))
    o <- order(geneid)
  else
    o <- order(geneid,exonid)
  geneid <- geneid[o]
  exon.genes <- exon.genes[o,,drop=FALSE]
  exon.coefficients <- fit$coefficients[o,,drop=FALSE]
  exon.stdev.unscaled <- fit$stdev.unscaled[o,,drop=FALSE]
  exon.df.residual <- fit$df.residual[o]
  exon.s2 <- fit$sigma[o]^2

  # Count exons by gene and get genewise variances
  exon.stat <- cbind(1,exon.df.residual,exon.s2)
  gene.sum <- rowsum(exon.stat,geneid,reorder=FALSE)
  gene.nexons <- gene.sum[,1]
  gene.df.residual <- gene.sum[,2]
  gene.s2 <- gene.sum[,3] / gene.sum[,1]
  if(verbose) {
    cat("Total number of exons: ", length(geneid), "\n")
    cat("Total number of genes: ", length(gene.nexons), "\n")
    cat("Number of genes with 1 exon: ", sum(gene.nexons==1), "\n")
    cat("Mean number of exons in a gene: ", round(mean(gene.nexons),0), "\n")
    cat("Max number of exons in a gene: ", max(gene.nexons), "\n")
  }

  # Posterior genewise variances
  squeeze <- squeezeVar(var=exon.s2, df=exon.df.residual, robust=robust)


  # Remove genes with only 1 exon
  gene.keep <- gene.nexons>1
  ngenes <- sum(gene.keep)
  if(ngenes==0) stop("No genes with more than one exon")

  exon.keep <- rep(gene.keep,gene.nexons)
  geneid <- geneid[exon.keep]
  exon.genes <- exon.genes[exon.keep,,drop=FALSE]
  exon.coefficients <- exon.coefficients[exon.keep,,drop=FALSE]
  exon.stdev.unscaled <- exon.stdev.unscaled[exon.keep,,drop=FALSE]
  exon.df.residual <- exon.df.residual[exon.keep]

  gene.nexons <- gene.nexons[gene.keep]
  gene.df.test <- gene.nexons-1
  gene.df.residual <- gene.df.residual[gene.keep]
  if(robust) squeeze$df.prior <- squeeze$df.prior[gene.keep]
  exon.df.total <- exon.df.residual
  exon.df.total <- pmin(exon.df.total,sum(exon.df.residual))
  gene.df.total <- rowsum(exon.df.total,geneid,reorder=FALSE)
  exon.s2.post <- squeeze$var.post[exon.keep]

  # Genewise betas
  u2 <- 1/(exon.stdev.unscaled^2*exon.s2.post)
  u2.rowsum <- rowsum(u2,geneid,reorder=FALSE)
  gene.betabar <- rowsum(exon.coefficients*u2,geneid,reorder=FALSE) / u2.rowsum

  # T-statistics for exon-level tests
  g <- rep(seq_len(ngenes), times=gene.nexons)
  exon.coefficients <- exon.coefficients-gene.betabar[g,,drop=FALSE]
  exon.1mleverage <- 1 - (u2 / u2.rowsum[g,,drop=FALSE])
  exon.coefficients <- exon.coefficients / exon.1mleverage
  exon.t <- exon.coefficients / exon.stdev.unscaled / sqrt(exon.s2.post)
  gene.F <- rowsum(exon.t^2,geneid,reorder=FALSE) / gene.df.test

  exon.p.value <- 2 * pt(abs(exon.t), df=gene.df.total[g], lower.tail=FALSE)
  gene.F.p.value <- pf(gene.F, df1=gene.df.test, df2=gene.df.total,
                       lower.tail=FALSE)

  # Exon level output
  out <- new("MArrayLM",list())
  out$genes <- exon.genes
  out$genecolname <- genecolname
  out$exoncolname <- exoncolname
  out$coefficients <- exon.coefficients
  out$t <- exon.t
  out$p.value <- exon.p.value

  # Gene level output
  out$gene.df.prior <- squeeze$df.prior
  out$gene.df.residual <- gene.df.residual
  out$gene.df.total <- gene.df.total
  out$gene.s2 <- gene.s2[gene.keep]
  out$gene.F <- gene.F
  out$gene.F.p.value <- gene.F.p.value

  # Which columns of exon.genes contain gene level annotation?
  gene.lastexon <- cumsum(gene.nexons)
  gene.firstexon <- gene.lastexon-gene.nexons+1
  no <- logical(nrow(exon.genes))
  isdup <- vapply(exon.genes,duplicated,no)[-gene.firstexon,,drop=FALSE]
  isgenelevel <- apply(isdup,2,all)
  out$gene.genes <- exon.genes[gene.lastexon,isgenelevel, drop=FALSE]
  out$gene.genes$NExons <- gene.nexons
  out$gene.firstexon <- gene.firstexon
  out$gene.lastexon <- gene.lastexon

  # Simes adjustment of exon level p-values
  penalty <- rep_len(1L,length(g))
  penalty[gene.lastexon] <- 1L-gene.nexons
  penalty <- cumsum(penalty)[-gene.lastexon]
  penalty <- penalty / rep(gene.nexons-1L,gene.nexons-1L)
  g2 <- g[-gene.lastexon]

  out$gene.simes.p.value <- gene.F.p.value
  for (j in seq_len(ncol(fit))) {
    o <- order(g,exon.p.value[,j])
    p.adj <- pmin(exon.p.value[o,j][-gene.lastexon] / penalty, 1)
    o <- order(g2,p.adj)
    out$gene.simes.p.value[,j] <- p.adj[o][gene.firstexon-0L:(ngenes-1L)]
  }

  out
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{addNormalizedAssays}
\alias{addNormalizedAssays}
\title{addNormalizedAssays}
\usage{
addNormalizedAssays(se, readLength = 50L)
}
\arguments{
\item{se}{A bin-wise `SummarizedExperiment` as produced by
\code{\link{countFeatures}}}

\item{readLength}{Used as a minimum width to estimate read density
(default 50).}
}
\value{
The `se` object with populated `logcpm` and `logNormDensity` assays.
}
\description{
addNormalizedAssays
}
\examples{
data(example_bin_se)
example_bin_se <- addNormalizedAssays(example_bin_se)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/countFeatures.R
\name{countFeatures}
\alias{countFeatures}
\title{countFeatures}
\usage{
countFeatures(
  bamfiles,
  bins,
  strandSpecific = 0,
  readLength = 50L,
  allowMultiOverlap = TRUE,
  inclNormalized = TRUE,
  tmpDir = tempdir(),
  ...
)
}
\arguments{
\item{bamfiles}{A vector of paths to bam files}

\item{bins}{A GRanges of bins in which to count reads (or path to a rds file
containing such an object}

\item{strandSpecific}{Passed to `Rsubread::featureCounts`}

\item{readLength}{Used as a minimum width to estimate read density.}

\item{allowMultiOverlap}{Passed to `Rsubread::featureCounts`}

\item{inclNormalized}{Logical; whether to include normalized assays (needed
for plotting)}

\item{tmpDir}{Passed to `Rsubread::featureCounts`}

\item{...}{Passed to `Rsubread::featureCounts`}
}
\value{
A \link[SummarizedExperiment]{RangedSummarizedExperiment-class}
}
\description{
countFeatures
}
\examples{
data("example_gene_annotation", package="diffUTR")
bins <- prepareBins(example_gene_annotation)
bam_files <- list.files(system.file("extdata", package="diffUTR"),
                        pattern="bam$", full=TRUE)
# not run
# se <- countFeatures(bam_files, bins, verbose=FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geneLevel.R
\name{simesAggregation}
\alias{simesAggregation}
\title{simesAggregation}
\usage{
simesAggregation(p.value, geneid)
}
\arguments{
\item{p.value}{A vector of p-values}

\item{geneid}{A vector of group labels such as gene identifiers}
}
\value{
A named vector of aggregated p-values
}
\description{
Simes p-value correction and aggregation, adapted from
\code{link[limma]{diffSplice}}
}
\examples{
p <- runif(50)
genes <- sample(LETTERS,50,replace=TRUE)
simesAggregation(p, genes)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{geneBinHeatmap}
\alias{geneBinHeatmap}
\title{geneBinHeatmap}
\usage{
geneBinHeatmap(
  se,
  gene,
  what = NULL,
  anno_rows = c("type", "logWidth", "meanLogDensity", "log10PValue", "geneAmbiguous"),
  anno_columns = c(),
  anno_colors = list(),
  removeAmbiguous = FALSE,
  merge_legends = TRUE,
  cluster_columns = FALSE,
  minDensityRatio = 0.1,
  left_annotation = NULL,
  top_annotation = NULL,
  ...
)
}
\arguments{
\item{se}{A bin-wise SummarizedExperiment as produced by
\code{\link{countFeatures}}}

\item{gene}{The gene of interest}

\item{what}{Type of values (i.e. assay) to plot}

\item{anno_rows}{Row annotation columns (i.e. columns of `rowData(se)`) to
plot}

\item{anno_columns}{Column annotation columns (i.e. columns of
`colData(se)`) to plot}

\item{anno_colors}{Annotation colors, as a list named with the row/column
annotations, see `\code{\link[ComplexHeatmap]{SingleAnnotation}}` for
details. Ignored if `left_annotation` and/or `top_annotation` are given
directly.}

\item{removeAmbiguous}{Logical; whether to remove bins that are
gene-ambiguous (i.e. overlap multiple genes).}

\item{merge_legends}{Logical; whether to merge legends. This effectively
calls `draw(..., merge_legends=TRUE)` around the heatmap.}

\item{cluster_columns}{Logical; whether to cluster columns (passed to
\code{\link[ComplexHeatmap]{Heatmap}})}

\item{minDensityRatio}{Minimum ratio of read density (with respect to the 
gene's average) for a bin to be plotted.}

\item{left_annotation}{Passed to \code{\link[ComplexHeatmap]{Heatmap}},
overrides `anno_rows`.}

\item{top_annotation}{Passed to \code{\link[ComplexHeatmap]{Heatmap}},
overrides `anno_columns`.}

\item{...}{Passed to `ComplexHeatmap` (see
\code{\link[ComplexHeatmap]{Heatmap}})}
}
\value{
A \code{\link[ComplexHeatmap]{Heatmap}}
}
\description{
A wrapper around `ComplexHeatmap`.
}
\examples{
data(example_bin_se)
se <- diffSpliceWrapper(example_bin_se, ~condition)
geneBinHeatmap(se, "Jund")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepareBins.R
\name{prepareBins}
\alias{prepareBins}
\title{prepareBins}
\usage{
prepareBins(
  g,
  APA = NULL,
  onlyMainChr = TRUE,
  removeAntisense = TRUE,
  chrStyle = NULL,
  maxUTRbinSize = 15000,
  codingOnly = FALSE,
  genewise = FALSE,
  stranded = FALSE,
  verbose = TRUE
)
}
\arguments{
\item{g}{A GRanges (or path to RDS file containing a GRanges) or path to a
gtf file or EnsDb object containing the gene annotation.}

\item{APA}{A GRanges (or path to a GRanges in RDS format) or bed file
containing the alternative poly-A site database}

\item{onlyMainChr}{Logical; whether to keep only main chromosomes}

\item{removeAntisense}{Logical; whether to remove antisense APA sites}

\item{chrStyle}{Chromosome notation to convert to (default no conversion)}

\item{maxUTRbinSize}{Max width of new alternative UTR bins}

\item{codingOnly}{Logical, whether to keep only coding transcripts}

\item{genewise}{Logical, whether annotation should be flattened genewise}

\item{stranded}{Logical, whether to perform disjoin in a stranded fashion.}

\item{verbose}{Logical, whether to print run information}
}
\value{
A `GRanges` object.
}
\description{
prepareBins
}
\details{
See the vignette for more details.
}
\examples{
data(example_gene_annotation)
bins <- prepareBins(example_gene_annotation)
}
\author{
Stefan Greber
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{deuBinPlot}
\alias{deuBinPlot}
\title{deuBinPlot}
\usage{
deuBinPlot(
  se,
  gene,
  type = c("summary", "condition", "sample"),
  intronSize = 2,
  exonSize = c("sqrt", "linear", "log"),
  y = NULL,
  condition = NULL,
  size = "type",
  lineSize = 1,
  colour = NULL,
  alpha = NULL,
  removeAmbiguous = TRUE,
  minDensityRatio = 0.1
)
}
\arguments{
\item{se}{A bin-wise SummarizedExperiment as produced by
\code{\link{countFeatures}} and including bin-level tests (i.e. having been
passed through one of the DEU wrappers such as
\code{\link{diffSpliceWrapper}} or \code{\link{DEXSeqWrapper}})}

\item{gene}{The gene of interest}

\item{type}{Either 'summary' (plot DEU summary), 'sample' (plot sample-wise
data), or 'condition' (plot data aggregate by condition)}

\item{intronSize}{Intron plot size. If <=3, intron size will be this
fraction of the mean exon size. If >3, each intron will have the given size.}

\item{exonSize}{Scaling for exon sizes, either 'sqrt', 'log', or 'linear'.}

\item{y}{Value to plot on the y-axis. If `type="summary"`, this should be a
column of `rowData(se)`, otherwise should be an assay name of `se`.}

\item{condition}{The colData column containing the samples' condition.}

\item{size}{rowData variable to use to determine the thickness of the bins.}

\item{lineSize}{Size of the line connecting the bins. Use `lineSize=0` to
omit the line.}

\item{colour}{rowData variable to use to determine the colour of the bins.
If `type="condition"`, can also be "condition"; if `type="sample"` can be
any colData column.}

\item{alpha}{Alpha level, passed to ggplot.}

\item{removeAmbiguous}{Logical; whether to remove bins that are
gene-ambiguous (i.e. overlap multiple genes).}

\item{minDensityRatio}{Minimum ratio of read density (with respect to the 
gene's average) for a bin to be plotted.}
}
\value{
A ggplot object
}
\description{
deuBinPlot
}
\examples{
data(example_bin_se)
se <- diffSpliceWrapper(example_bin_se, ~condition)
deuBinPlot(se, "Jund")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{rn6_PAS}
\alias{rn6_PAS}
\title{Poly-A sites compendium for Rattus Norvegicus (Rno6)}
\value{
a `GRanges` object
}
\description{
These are the sites from polyA_DB release 3.2, downloaded from
\url{https://exon.apps.wistar.org/PolyA_DB/v3/download/3.2/rat_pas.zip},
and lifted over to Rno6.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffSplice2.R
\name{diffSplice2}
\alias{diffSplice2}
\title{diffSplice2}
\usage{
diffSplice2(fit, geneid, exonid = NULL, robust = FALSE, verbose = TRUE)
}
\arguments{
\item{fit}{an \code{\link[limma]{MArrayLM-class}} fitted model object
produced by \code{\link[limma]{lmFit}} or `contrasts.fit`, with rows
corresponding to exons.}

\item{geneid}{gene identifiers (as in \code{\link[limma]{diffSplice}})}

\item{exonid}{exon identifiers (as in \code{\link[limma]{diffSplice}})}

\item{robust}{logical, should the estimation of the empirical Bayes prior
parameters be robustified against outlier sample variances?}

\item{verbose}{logical, if TRUE will output some diagnostic information}
}
\value{
An \code{\link[limma]{MArrayLM-class}} object containing both exon
level and gene level tests. Results are sorted by geneid and by exonid
within gene.
}
\description{
This is a small improvement to the \code{\link[limma]{diffSplice}} function
written by Gordon Smyth and Charity Law.
}
\examples{
library(SummarizedExperiment)
library(edgeR)
data(example_bin_se)
se <- example_bin_se
design <- model.matrix(~condition, data=as.data.frame(colData(se)))
dds <- calcNormFactors(DGEList(assays(se)$counts))
dds <- voom(dds, design)
dds <- lmFit(dds, design)
res <- diffSplice2(dds, geneid=rowData(se)$gene, exonid=row.names(se))
topSplice(res)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEU_wrappers.R
\name{diffSpliceDGEWrapper}
\alias{diffSpliceDGEWrapper}
\alias{DEUwrappers}
\alias{diffSpliceWrapper}
\alias{DEXSeqWrapper}
\title{DEUwrappers}
\usage{
diffSpliceDGEWrapper(
  se,
  design,
  coef = NULL,
  QLF = TRUE,
  robust = TRUE,
  countFilter = TRUE,
  excludeTypes = NULL
)

diffSpliceWrapper(
  se,
  design,
  coef = NULL,
  robust = TRUE,
  improved = TRUE,
  countFilter = TRUE,
  excludeTypes = NULL
)

DEXSeqWrapper(
  se,
  design = ~sample + exon + condition:exon,
  reducedModel = ~sample + exon,
  excludeTypes = NULL,
  ...
)
}
\arguments{
\item{se}{A bin-wise SummarizedExperiment as produced by
\code{\link{countFeatures}}}

\item{design}{A formula (using columns of `colData(se)`) or (for
`diffSpliceWrapper` or `diffSpliceDGEWrapper` only) a model.matrix.}

\item{coef}{The coefficient to be tested (ignored for `DEXSeqWrapper`).}

\item{QLF}{Logical; whether to use edgeR's quasi-likelihood negative
binomial (applicable only to `diffSpliceDGEWrapper`).}

\item{robust}{Logical; whether to use robust fitting for the dispersion
trend (ignored for `DEXSeqWrapper`).}

\item{countFilter}{Logical; whether to filter out low-count bins (ignored
for `DEXSeqWrapper`).}

\item{excludeTypes}{A vector of bin types to ignore for testing. To test
for any kind of differential usage, leave empty. To test for differential
UTR usage, use `excludeTypes=c("CDS","non-coding")` (or see
 \code{\link{geneLevelStats}} for more options).}

\item{improved}{Logical; whether to use \code{\link{diffSplice2}} instead
of the original \code{\link[limma]{diffSplice}} (default TRUE).}

\item{reducedModel}{A reduced formula (applicable only to `DEXSeqWrapper`).}

\item{...}{Further arguments (passed to `testForDEU` and
`estimateExonFoldChanges`) of `DEXSeq`. Can for instance be used to enable 
multithreading, by passing `BPPARAM=BiocParallel::MulticoreParam(ncores)`.}
}
\value{
The `se` object with additional rowData columns contain bin (i.e.
exon) -level statistics, and a metadata slot containing gene level p-values.
}
\description{
Wrappers around commonly-used DEU methods
(\code{\link[edgeR]{diffSpliceDGE}}, \code{\link[DEXSeq]{DEXSeq}} and an
improved version of \code{\link[limma]{diffSplice}}
}
\examples{
library(SummarizedExperiment)
data(example_bin_se)
se <- diffSpliceWrapper(example_bin_se, ~condition)
head(rowData(se))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{example_gene_annotation}
\alias{example_gene_annotation}
\title{Example gene annotation}
\value{
a `GRanges` object
}
\description{
An example gene annotation containing only a small subset of mouse genes.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{example_bin_se}
\alias{example_bin_se}
\title{Example bin-level `RangedSummarizedExperiment`}
\value{
a `RangedSummarizedExperiment`
}
\description{
An object produced by \code{\link{countFeatures}} containing small subset of
 genes from mouse hippocampal slices undergoing Forskolin-induced long-term
potentiation (GSE84643).
}
\references{
\url{https://www.nature.com/articles/s41598-017-17407-w}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{plotTopGenes}
\alias{plotTopGenes}
\title{plotTopGenes}
\usage{
plotTopGenes(se, n = 10, FDR = 0.05, diffUTR = FALSE, alpha = 1, ...)
}
\arguments{
\item{se}{A bin-wise SummarizedExperiment as produced by
\code{\link{countFeatures}} and including bin-level tests (i.e. having been
passed through one of the DEU wrappers such as
\code{\link{diffSpliceWrapper}} or \code{\link{DEXSeqWrapper}})}

\item{n}{The maximum number of genes for which to plot labels}

\item{FDR}{The FDR threshold above which to plot labels}

\item{diffUTR}{Logical; if FALSE, uses absolute coefficients (appropriate
for normal differential exon usage); if TRUE, uses non-absolute (ie changes
should be in the same direction across significant bins) and width-weighted
scores (i.e. larger bins have more weight) -- this is relevant only when
testing UTR usage.}

\item{alpha}{Points transparency}

\item{...}{Passed to \link[ggrepel]{geom_label_repel}; this can for instance
be used to increase `max.overlaps` when not all desired gene labels are 
displayed)}
}
\value{
A ggplot
}
\description{
plotTopGenes
}
\examples{
data(example_bin_se)
se <- diffSpliceWrapper(example_bin_se, ~condition)
plotTopGenes(se)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geneLevel.R
\name{geneLevelStats}
\alias{geneLevelStats}
\title{geneLevelStats}
\usage{
geneLevelStats(
  se,
  coef = NULL,
  excludeTypes = NULL,
  includeTypes = NULL,
  returnSE = TRUE,
  minDensityRatio = 0.1,
  minWidth = 20,
  excludeGeneAmbiguous = TRUE
)
}
\arguments{
\item{se}{A `RangedSummarizedExperiment` containing the results of one of
the DEU wrappers.}

\item{coef}{The coefficients tested (if the model included more than one
term).}

\item{excludeTypes}{Vector of bin types to exclude.}

\item{includeTypes}{Vector of bin types to include (overrides
`excludeTypes`)}

\item{returnSE}{Logical; whether to return the updated `se` object
(default), or the gene-level table.}

\item{minDensityRatio}{Minimum ratio of read density (with respect to the 
gene's average) for a bin to be included.}

\item{minWidth}{Minimum bin width to include}

\item{excludeGeneAmbiguous}{Logical; whether to exclude bins which are 
ambiguous (i.e. can be from different genes)}
}
\value{
If `returnSE=TRUE` (default), returns the `se` object with an
updated `metadata(se)$geneLevel` slot, otherwise returns the gene-level
data.frame.
}
\description{
Aggregates bin-level statistics to the gene-level
}
\examples{
library(SummarizedExperiment)
data(example_bin_se)
se <- diffSpliceWrapper(example_bin_se, ~condition)
se <- geneLevelStats(se, includeTypes="3UTR")
head(metadata(se)$geneLevel)
}
